Index: branches/SHM-2.0-dev/cfg/encoder_intra_main.cfg
===================================================================
--- branches/SHM-2.0-dev/cfg/encoder_intra_main.cfg	(revision 167)
+++ branches/SHM-2.0-dev/cfg/encoder_intra_main.cfg	(revision 168)
@@ -95,4 +95,6 @@
 TransquantBypassEnableFlag: 0  # Value of PPS flag.
 CUTransquantBypassFlagValue: 0 # Constant lossless-value signaling per CU, if TransquantBypassEnableFlag is 1.
+
+SEIpictureDigest               : 1
                                                        
 ### DO NOT ADD ANYTHING BELOW THIS LINE ###
Index: branches/SHM-2.0-dev/cfg/encoder_lowdelay_P_main.cfg
===================================================================
--- branches/SHM-2.0-dev/cfg/encoder_lowdelay_P_main.cfg	(revision 167)
+++ branches/SHM-2.0-dev/cfg/encoder_lowdelay_P_main.cfg	(revision 168)
@@ -110,4 +110,6 @@
 RCForceIntraQP                      : 0                # Rate control: force intra QP to be equal to initial QP
 
+SEIpictureDigest                    : 1
+
 ### DO NOT ADD ANYTHING BELOW THIS LINE ###
 ### DO NOT DELETE THE EMPTY LINE BELOW ###
Index: branches/SHM-2.0-dev/cfg/encoder_lowdelay_main.cfg
===================================================================
--- branches/SHM-2.0-dev/cfg/encoder_lowdelay_main.cfg	(revision 167)
+++ branches/SHM-2.0-dev/cfg/encoder_lowdelay_main.cfg	(revision 168)
@@ -110,4 +110,6 @@
 RCForceIntraQP                      : 0                # Rate control: force intra QP to be equal to initial QP
 
+SEIpictureDigest                    : 1
+
 ### DO NOT ADD ANYTHING BELOW THIS LINE ###
 ### DO NOT DELETE THE EMPTY LINE BELOW ###
Index: branches/SHM-2.0-dev/cfg/encoder_randomaccess_main.cfg
===================================================================
--- branches/SHM-2.0-dev/cfg/encoder_randomaccess_main.cfg	(revision 167)
+++ branches/SHM-2.0-dev/cfg/encoder_randomaccess_main.cfg	(revision 168)
@@ -114,4 +114,6 @@
 RCForceIntraQP                      : 0                # Rate control: force intra QP to be equal to initial QP
 
+SEIpictureDigest                    : 1
+
 ### DO NOT ADD ANYTHING BELOW THIS LINE ###
 ### DO NOT DELETE THE EMPTY LINE BELOW ###
Index: branches/SHM-2.0-dev/cfg/per-sequence-svc/BQTerrace-1.5x.cfg
===================================================================
--- branches/SHM-2.0-dev/cfg/per-sequence-svc/BQTerrace-1.5x.cfg	(revision 167)
+++ branches/SHM-2.0-dev/cfg/per-sequence-svc/BQTerrace-1.5x.cfg	(revision 168)
@@ -3,4 +3,5 @@
 FrameSkip                     : 0           # Number of frames to be skipped in input
 FramesToBeEncoded             : 600         # Number of frames to be coded
+AvcBase                       : 0           # AVC coded base layer as an input
 
 #======== File I/O ===============
@@ -19,3 +20,5 @@
 IntraPeriod1                  : 64          # Period of I-Frame ( -1 = only first)
 ConformanceMode1              : 1           # conformance mode
+NumDirectRefLayers1           : 1           # number of direct reference layers
+RefLayerIds1                  : 0           # reference layer id
 QP1: 20
Index: branches/SHM-2.0-dev/cfg/per-sequence-svc/BQTerrace-2x.cfg
===================================================================
--- branches/SHM-2.0-dev/cfg/per-sequence-svc/BQTerrace-2x.cfg	(revision 167)
+++ branches/SHM-2.0-dev/cfg/per-sequence-svc/BQTerrace-2x.cfg	(revision 168)
@@ -3,4 +3,5 @@
 FrameSkip                     : 0           # Number of frames to be skipped in input
 FramesToBeEncoded             : 600         # Number of frames to be coded
+AvcBase                       : 0           # AVC coded base layer as an input
 
 #======== File I/O ===============
@@ -19,3 +20,5 @@
 IntraPeriod1                  : 64          # Period of I-Frame ( -1 = only first)
 ConformanceMode1              : 1           # conformance mode
+NumDirectRefLayers1           : 1           # number of direct reference layers
+RefLayerIds1                  : 0           # reference layer id
 QP1: 20
Index: branches/SHM-2.0-dev/cfg/per-sequence-svc/BQTerrace-SNR.cfg
===================================================================
--- branches/SHM-2.0-dev/cfg/per-sequence-svc/BQTerrace-SNR.cfg	(revision 167)
+++ branches/SHM-2.0-dev/cfg/per-sequence-svc/BQTerrace-SNR.cfg	(revision 168)
@@ -3,4 +3,5 @@
 FrameSkip                     : 0           # Number of frames to be skipped in input
 FramesToBeEncoded             : 600         # Number of frames to be coded
+AvcBase                       : 0           # AVC coded base layer as an input
 
 #======== File I/O ===============
@@ -19,3 +20,5 @@
 IntraPeriod1                  : 64          # Period of I-Frame ( -1 = only first)
 ConformanceMode1              : 1           # conformance mode
+NumDirectRefLayers1           : 1           # number of direct reference layers
+RefLayerIds1                  : 0           # reference layer id
 QP1: 20
Index: branches/SHM-2.0-dev/cfg/per-sequence-svc/BasketballDrive-1.5x.cfg
===================================================================
--- branches/SHM-2.0-dev/cfg/per-sequence-svc/BasketballDrive-1.5x.cfg	(revision 167)
+++ branches/SHM-2.0-dev/cfg/per-sequence-svc/BasketballDrive-1.5x.cfg	(revision 168)
@@ -3,4 +3,5 @@
 FrameSkip                     : 0           # Number of frames to be skipped in input
 FramesToBeEncoded             : 500         # Number of frames to be coded
+AvcBase                       : 0           # AVC coded base layer as an input
 
 #======== File I/O ===============
@@ -19,3 +20,5 @@
 IntraPeriod1                  : 48          # Period of I-Frame ( -1 = only first)
 ConformanceMode1              : 1           # conformance mode
+NumDirectRefLayers1           : 1           # number of direct reference layers
+RefLayerIds1                  : 0           # reference layer id
 QP1: 20
Index: branches/SHM-2.0-dev/cfg/per-sequence-svc/BasketballDrive-2x.cfg
===================================================================
--- branches/SHM-2.0-dev/cfg/per-sequence-svc/BasketballDrive-2x.cfg	(revision 167)
+++ branches/SHM-2.0-dev/cfg/per-sequence-svc/BasketballDrive-2x.cfg	(revision 168)
@@ -3,4 +3,5 @@
 FrameSkip                     : 0           # Number of frames to be skipped in input
 FramesToBeEncoded             : 500         # Number of frames to be coded
+AvcBase                       : 0           # AVC coded base layer as an input
 
 #======== File I/O ===============
@@ -19,3 +20,5 @@
 IntraPeriod1                  : 48          # Period of I-Frame ( -1 = only first)
 ConformanceMode1              : 1           # conformance mode
+NumDirectRefLayers1           : 1           # number of direct reference layers
+RefLayerIds1                  : 0           # reference layer id
 QP1: 20
Index: branches/SHM-2.0-dev/cfg/per-sequence-svc/BasketballDrive-SNR.cfg
===================================================================
--- branches/SHM-2.0-dev/cfg/per-sequence-svc/BasketballDrive-SNR.cfg	(revision 167)
+++ branches/SHM-2.0-dev/cfg/per-sequence-svc/BasketballDrive-SNR.cfg	(revision 168)
@@ -3,4 +3,5 @@
 FrameSkip                     : 0           # Number of frames to be skipped in input
 FramesToBeEncoded             : 500         # Number of frames to be coded
+AvcBase                       : 0           # AVC coded base layer as an input
 
 #======== File I/O ===============
@@ -19,3 +20,5 @@
 IntraPeriod1                  : 48          # Period of I-Frame ( -1 = only first)
 ConformanceMode1              : 1           # conformance mode
+NumDirectRefLayers1           : 1           # number of direct reference layers
+RefLayerIds1                  : 0           # reference layer id
 QP1: 20
Index: branches/SHM-2.0-dev/cfg/per-sequence-svc/Cactus-1.5x.cfg
===================================================================
--- branches/SHM-2.0-dev/cfg/per-sequence-svc/Cactus-1.5x.cfg	(revision 167)
+++ branches/SHM-2.0-dev/cfg/per-sequence-svc/Cactus-1.5x.cfg	(revision 168)
@@ -3,4 +3,5 @@
 FrameSkip                     : 0           # Number of frames to be skipped in input
 FramesToBeEncoded             : 500         # Number of frames to be coded
+AvcBase                       : 0           # AVC coded base layer as an input
 
 #======== File I/O ===============
@@ -19,3 +20,5 @@
 IntraPeriod1                  : 48          # Period of I-Frame ( -1 = only first)
 ConformanceMode1              : 1           # conformance mode
+NumDirectRefLayers1           : 1           # number of direct reference layers
+RefLayerIds1                  : 0           # reference layer id
 QP1: 20
Index: branches/SHM-2.0-dev/cfg/per-sequence-svc/Cactus-2x.cfg
===================================================================
--- branches/SHM-2.0-dev/cfg/per-sequence-svc/Cactus-2x.cfg	(revision 167)
+++ branches/SHM-2.0-dev/cfg/per-sequence-svc/Cactus-2x.cfg	(revision 168)
@@ -3,4 +3,5 @@
 FrameSkip                     : 0           # Number of frames to be skipped in input
 FramesToBeEncoded             : 500         # Number of frames to be coded
+AvcBase                       : 0           # AVC coded base layer as an input
 
 #======== File I/O ===============
@@ -19,3 +20,5 @@
 IntraPeriod1                  : 48          # Period of I-Frame ( -1 = only first)
 ConformanceMode1              : 1           # conformance mode
+NumDirectRefLayers1           : 1           # number of direct reference layers
+RefLayerIds1                  : 0           # reference layer id
 QP1: 20
Index: branches/SHM-2.0-dev/cfg/per-sequence-svc/Cactus-SNR.cfg
===================================================================
--- branches/SHM-2.0-dev/cfg/per-sequence-svc/Cactus-SNR.cfg	(revision 167)
+++ branches/SHM-2.0-dev/cfg/per-sequence-svc/Cactus-SNR.cfg	(revision 168)
@@ -3,4 +3,5 @@
 FrameSkip                     : 0           # Number of frames to be skipped in input
 FramesToBeEncoded             : 500         # Number of frames to be coded
+AvcBase                       : 0           # AVC coded base layer as an input
 
 #======== File I/O ===============
@@ -19,3 +20,5 @@
 IntraPeriod1                  : 48          # Period of I-Frame ( -1 = only first)
 ConformanceMode1              : 1           # conformance mode
+NumDirectRefLayers1           : 1           # number of direct reference layers
+RefLayerIds1                  : 0           # reference layer id
 QP1: 20
Index: branches/SHM-2.0-dev/cfg/per-sequence-svc/Kimono-1.5x.cfg
===================================================================
--- branches/SHM-2.0-dev/cfg/per-sequence-svc/Kimono-1.5x.cfg	(revision 167)
+++ branches/SHM-2.0-dev/cfg/per-sequence-svc/Kimono-1.5x.cfg	(revision 168)
@@ -3,4 +3,5 @@
 FrameSkip                     : 0           # Number of frames to be skipped in input
 FramesToBeEncoded             : 240         # Number of frames to be coded
+AvcBase                       : 0           # AVC coded base layer as an input
 
 #======== File I/O ===============
@@ -19,3 +20,5 @@
 IntraPeriod1                  : 24          # Period of I-Frame ( -1 = only first)
 ConformanceMode1              : 1           # conformance mode
+NumDirectRefLayers1           : 1           # number of direct reference layers
+RefLayerIds1                  : 0           # reference layer id
 QP1: 20
Index: branches/SHM-2.0-dev/cfg/per-sequence-svc/Kimono-2x.cfg
===================================================================
--- branches/SHM-2.0-dev/cfg/per-sequence-svc/Kimono-2x.cfg	(revision 167)
+++ branches/SHM-2.0-dev/cfg/per-sequence-svc/Kimono-2x.cfg	(revision 168)
@@ -3,4 +3,5 @@
 FrameSkip                     : 0           # Number of frames to be skipped in input
 FramesToBeEncoded             : 240         # Number of frames to be coded
+AvcBase                       : 0           # AVC coded base layer as an input
 
 #======== File I/O ===============
@@ -19,3 +20,5 @@
 IntraPeriod1                  : 24          # Period of I-Frame ( -1 = only first)
 ConformanceMode1              : 1           # conformance mode
+NumDirectRefLayers1           : 1           # number of direct reference layers
+RefLayerIds1                  : 0           # reference layer id
 QP1: 20
Index: branches/SHM-2.0-dev/cfg/per-sequence-svc/Kimono-SNR.cfg
===================================================================
--- branches/SHM-2.0-dev/cfg/per-sequence-svc/Kimono-SNR.cfg	(revision 167)
+++ branches/SHM-2.0-dev/cfg/per-sequence-svc/Kimono-SNR.cfg	(revision 168)
@@ -3,4 +3,5 @@
 FrameSkip                     : 0           # Number of frames to be skipped in input
 FramesToBeEncoded             : 240         # Number of frames to be coded
+AvcBase                       : 0           # AVC coded base layer as an input
 
 #======== File I/O ===============
@@ -19,3 +20,5 @@
 IntraPeriod1                  : 24          # Period of I-Frame ( -1 = only first)
 ConformanceMode1              : 1           # conformance mode
+NumDirectRefLayers1           : 1           # number of direct reference layers
+RefLayerIds1                  : 0           # reference layer id
 QP1: 20
Index: branches/SHM-2.0-dev/cfg/per-sequence-svc/ParkScene-1.5x.cfg
===================================================================
--- branches/SHM-2.0-dev/cfg/per-sequence-svc/ParkScene-1.5x.cfg	(revision 167)
+++ branches/SHM-2.0-dev/cfg/per-sequence-svc/ParkScene-1.5x.cfg	(revision 168)
@@ -3,4 +3,5 @@
 FrameSkip                     : 0           # Number of frames to be skipped in input
 FramesToBeEncoded             : 240         # Number of frames to be coded
+AvcBase                       : 0           # AVC coded base layer as an input
 
 #======== File I/O ===============
@@ -19,3 +20,5 @@
 IntraPeriod1                  : 24          # Period of I-Frame ( -1 = only first)
 ConformanceMode1              : 1           # conformance mode
+NumDirectRefLayers1           : 1           # number of direct reference layers
+RefLayerIds1                  : 0           # reference layer id
 QP1: 20
Index: branches/SHM-2.0-dev/cfg/per-sequence-svc/ParkScene-2x.cfg
===================================================================
--- branches/SHM-2.0-dev/cfg/per-sequence-svc/ParkScene-2x.cfg	(revision 167)
+++ branches/SHM-2.0-dev/cfg/per-sequence-svc/ParkScene-2x.cfg	(revision 168)
@@ -3,4 +3,5 @@
 FrameSkip                     : 0           # Number of frames to be skipped in input
 FramesToBeEncoded             : 240         # Number of frames to be coded
+AvcBase                       : 0           # AVC coded base layer as an input
 
 #======== File I/O ===============
@@ -19,3 +20,5 @@
 IntraPeriod1                  : 24          # Period of I-Frame ( -1 = only first)
 ConformanceMode1              : 1           # conformance mode
+NumDirectRefLayers1           : 1           # number of direct reference layers
+RefLayerIds1                  : 0           # reference layer id
 QP1: 20
Index: branches/SHM-2.0-dev/cfg/per-sequence-svc/ParkScene-SNR.cfg
===================================================================
--- branches/SHM-2.0-dev/cfg/per-sequence-svc/ParkScene-SNR.cfg	(revision 167)
+++ branches/SHM-2.0-dev/cfg/per-sequence-svc/ParkScene-SNR.cfg	(revision 168)
@@ -3,4 +3,5 @@
 FrameSkip                     : 0           # Number of frames to be skipped in input
 FramesToBeEncoded             : 240         # Number of frames to be coded
+AvcBase                       : 0           # AVC coded base layer as an input
 
 #======== File I/O ===============
@@ -19,3 +20,5 @@
 IntraPeriod1                  : 24          # Period of I-Frame ( -1 = only first)
 ConformanceMode1              : 1           # conformance mode
+NumDirectRefLayers1           : 1           # number of direct reference layers
+RefLayerIds1                  : 0           # reference layer id
 QP1: 20
Index: branches/SHM-2.0-dev/cfg/per-sequence-svc/PeopleOnStreet-2x.cfg
===================================================================
--- branches/SHM-2.0-dev/cfg/per-sequence-svc/PeopleOnStreet-2x.cfg	(revision 167)
+++ branches/SHM-2.0-dev/cfg/per-sequence-svc/PeopleOnStreet-2x.cfg	(revision 168)
@@ -3,4 +3,5 @@
 FrameSkip                     : 0           # Number of frames to be skipped in input
 FramesToBeEncoded             : 150         # Number of frames to be coded
+AvcBase                       : 0           # AVC coded base layer as an input
 
 #======== File I/O ===============
@@ -19,3 +20,5 @@
 IntraPeriod1                  : 32          # Period of I-Frame ( -1 = only first)
 ConformanceMode1              : 1           # conformance mode
+NumDirectRefLayers1           : 1           # number of direct reference layers
+RefLayerIds1                  : 0           # reference layer id
 QP1: 20
Index: branches/SHM-2.0-dev/cfg/per-sequence-svc/PeopleOnStreet-SNR.cfg
===================================================================
--- branches/SHM-2.0-dev/cfg/per-sequence-svc/PeopleOnStreet-SNR.cfg	(revision 167)
+++ branches/SHM-2.0-dev/cfg/per-sequence-svc/PeopleOnStreet-SNR.cfg	(revision 168)
@@ -3,4 +3,5 @@
 FrameSkip                     : 0           # Number of frames to be skipped in input
 FramesToBeEncoded             : 150         # Number of frames to be coded
+AvcBase                       : 0           # AVC coded base layer as an input
 
 #======== File I/O ===============
@@ -19,3 +20,5 @@
 IntraPeriod1                  : 32          # Period of I-Frame ( -1 = only first)
 ConformanceMode1              : 1           # conformance mode
+NumDirectRefLayers1           : 1           # number of direct reference layers
+RefLayerIds1                  : 0           # reference layer id
 QP1: 20
Index: branches/SHM-2.0-dev/cfg/per-sequence-svc/Traffic-2x.cfg
===================================================================
--- branches/SHM-2.0-dev/cfg/per-sequence-svc/Traffic-2x.cfg	(revision 167)
+++ branches/SHM-2.0-dev/cfg/per-sequence-svc/Traffic-2x.cfg	(revision 168)
@@ -3,4 +3,5 @@
 FrameSkip                     : 0           # Number of frames to be skipped in input
 FramesToBeEncoded             : 300         # Number of frames to be coded
+AvcBase                       : 0           # AVC coded base layer as an input
 
 #======== File I/O ===============
@@ -19,3 +20,5 @@
 IntraPeriod1                  : 32          # Period of I-Frame ( -1 = only first)
 ConformanceMode1              : 1           # conformance mode
+NumDirectRefLayers1           : 1           # number of direct reference layers
+RefLayerIds1                  : 0           # reference layer id
 QP1: 20
Index: branches/SHM-2.0-dev/cfg/per-sequence-svc/Traffic-SNR.cfg
===================================================================
--- branches/SHM-2.0-dev/cfg/per-sequence-svc/Traffic-SNR.cfg	(revision 167)
+++ branches/SHM-2.0-dev/cfg/per-sequence-svc/Traffic-SNR.cfg	(revision 168)
@@ -3,4 +3,5 @@
 FrameSkip                     : 0           # Number of frames to be skipped in input
 FramesToBeEncoded             : 300         # Number of frames to be coded
+AvcBase                       : 0           # AVC coded base layer as an input
 
 #======== File I/O ===============
@@ -19,3 +20,5 @@
 IntraPeriod1                  : 32          # Period of I-Frame ( -1 = only first)
 ConformanceMode1              : 1           # conformance mode
+NumDirectRefLayers1           : 1           # number of direct reference layers
+RefLayerIds1                  : 0           # reference layer id
 QP1: 20